.gba
.open "zm.gba",".gba",0x8000000
;by:JumZhu.Diwa

.definelabel SpriteData,0x30001AC
.definelabel SpriteDataEnd,0x30006EC
.definelabel CurrSprite,0x3000738
.definelabel SpriteAiStart,875e8c0h
.definelabel SpriteRNG,300083Ch
.definelabel SpriteGfxPointers,0x875EBF8
.definelabel SpritePalPointers,0x875EEF0
.definelabel BeetomID,0x16				 ;Which sprite to replace
.definelabel PlaySound,8002A18h
.definelabel PlaySound2,8002b20h
.definelabel PlaySound3,8002c80h
.definelabel DirectionTag,800F8E0h       ;检查敌人与samus的左右位置
.definelabel SpriteDataPointers,82b0d68h
.definelabel PrimarySpriteStats,0x82B0D68
.definelabel CheckRange,800FDE0h
.definelabel CheckRange2,800FE48h
.definelabel CheckBlock,800F688h         ;检查7F1 适合头顶
.definelabel CheckBlock2,800F47Ch        ;检查7F0 适合身下
.definelabel CheckBlock3,800f720h
.definelabel DeathFireWorks,8011084h
.definelabel SpriteDrop,800E3D4h
.definelabel FrozenRoutine,800FFE8h
.definelabel StunSprite,8011280h
.definelabel XTagRAM,30007F0h
.definelabel YTagRAM,30007F1h
.definelabel UPOutWaterEffect,80116cch
.definelabel DropInWaterEffect,8011718h
.definelabel MakeWaterEffect,8011620h
.definelabel SetTheDirection,800F8B0h
.definelabel RandomDirection,800F80Ch
.definelabel CheckAnimation,800FBC8h
.definelabel CheckAnimation2,800FC00h
.definelabel Equipment,0x3001530
.definelabel AreaHeaderDataOffset,0x875FAC4
.definelabel CurrentArea,3000054h
.definelabel MetroidFrozenRoutine,801004Ch
.definelabel MetroidFastFrozenRoutine,80100A4h
.definelabel BomeDamageDidBeetom,0x8   ;The damage the bomb did to beetom (1-0xFF)


;06 前跳碰壁(非顶)次数,直跳归零
;07 连续直跳次数
;08 起跳强制转身标记 0 为随机 1为强转 2为强制不转 
;09 强制直立跳跃标记 前跳碰壁达到2次以上

;13 记录精灵吸附在samus身上flag

;2C 地面移动时间帧数 waitpose分配 跳跃非下降帧数 跳跃下落帧数
;2D 跳跃类型 直小0 直大1 前跳2
;2E 连续前跳次数
;2F Samus在范围内的标记
	
.org SpriteAiStart + BeetomID * 4
	.word BeetomMain + 1
	
.org SpriteGfxPointers + ( BeetomID - 10h ) * 4
	.word BeetomGfxPointers
	
.org SpritePalPointers + ( BeetomID - 10h ) * 4
	.word BeetomPalPointers


.org 0x8304054
BeetomMain:
	push	r4-r7,lr
	add		sp,-4h
	ldr		r4,=CurrSprite
	mov		r5,r4
	add		r5,20h
	ldrb	r0,[r5,4h]
	cmp		r0,09h
	bcs		@DeathPose
	mov		r0,r4
	bl		BeetomCheckBomeOrPowerBomeAttack
	ldrb	r0,[r5,4h]
	cmp		r0,09h
	bcs		@DeathPose
	ldrb	r0,[r4,13h]
	cmp		r0,0h
	bne		@@PassCheckIntersects
	bl		BeetomCheckSpriteAndSamusIntersects
@@PassCheckIntersects:	
	mov		r0,0h
	strb	r0,[r5,0Fh]			;在范围标记默认为0
	mov		r0,80h
	lsl		r0,r0,1h
	mov		r1,0B0h
	lsl		r1,r1,1h
	bl		CheckRange
	cmp		r0,0h
	beq		@@NoInRange
	strb	r0,[r5,0Fh]			;标记在范围
@@NoInRange:	
	ldrb	r0,[r5,12h]			;读取碰撞属性
	mov		r1,2h
	and		r1,r0
	cmp		r1,0h
	beq		@@NoHit
	mov		r1,0FDh
	and		r0,r1
	strb	r0,[r5,12h]			;去掉被击打的flag
	ldrb	r0,[r4]
	mov		r1,2h
	and		r1,r0
	cmp		r1,0h
	beq		@@NoHit
;	ldr		r0,=
;	bl		PlaySound2
@@NoHit:
	ldrb	r0,[r5,10h]
	cmp		r0,0h
	beq		@@NoFrozening
	bl		CancelSuckAndFrozening
	b 		@Thend
@@NoFrozening:	
	bl		StunSprite			;检查击晕值
	cmp		r0,0h
	beq		@@NoStun
	b		@Thend
.pool
@@NoStun:
	ldrb	r0,[r5,4h]			;读取pose
	lsl		r0,r0,2h
	ldr		r1,=BeetomPoseTable
	add		r0,r0,r1
	ldr		r0,[r0]
	mov		r15,r0
.pool
BeetomPoseTable:
	.word BeetomInitialize	;0
	.word BeetomWait		;1
	.word BeetomNormalMove	;2
	.word BeetomReJump		;3
	.word BeetomJump		;4
	.word BeetomFallFloor	;5
	.word BeetomFall		;6
	.word BeetomReSuck		;7
	.word BeetomSuck		;8
BeetomInitialize:
	bl		BeetomInitializePose
BeetomWait:
	bl		BeetomWaitPose
BeetomNormalMove:
	bl		BeetomNormalMovePose
	b		@Thend
BeetomReJump:
	bl		BeetomReJumpPose
	b		@Thend
BeetomJump:
	bl		BeetomJumpPose
	b		@Thend
BeetomFallFloor:
	bl		BeetomFallFloorPose
	b		@Thend
BeetomFall:
	bl		BeetomFallPose
	b		@Thend
BeetomReSuck:
	bl		BeetomReSuckPose
	b		@Thend
BeetomSuck:
	bl		BeetomSuckPose
	b		@Thend
@DeathPose:
	ldrh	r1,[r4,2h]
	sub		r1,20h
	ldrh	r2,[r4,4h]
	mov		r0,20h
	str		r0,[sp]
	mov		r3,1h
	mov		r0,0h
	bl		DeathFireWorks
@Thend:	
	add		sp,4h
	pop		r4-r7
	pop		r1
	bx		r1
.pool

BeetomInitializePose:					;0
	push	lr
	mov		r3,0h
	mov		r0,10h
	strb	r0,[r5,7h]
	mov		r0,18h
	strb	r0,[r5,8h]
	strb	r0,[r5,9h]
	mov		r0,3Eh
	neg		r0,r0
	strh	r0,[r4,0Ah]
	strh	r3,[r4,0Ch]
	mov		r0,20h
	strh	r0,[r4,10h]
	neg		r0,r0
	strh	r0,[r4,0Eh]
	ldr		r2,=SpriteDataPointers
	ldrb	r1,[r4,1Dh]
	lsl		r0,r1,3h
	add		r0,r0,r1
	lsl		r0,r0,1h
	add		r0,r0,r2
	ldrh	r0,[r0]
	strh	r0,[r4,14h]
	mov		r0,1h
	strb	r0,[r5,5h]
	strb	r0,[r5,4h]
	bl		RandomDirection
	pop		r1
	bx		r1
.pool	

BeetomWaitPose:               		;1
	push	lr
	mov		r3,0h
	ldr		r1,=SpriteRNG
	ldrb	r0,[r1]
	lsl		r0,r0,3h
	strb	r0,[r5,0Ch]				;随机记录爬行多久
	ldr		r0,=BeetomNormalOAM
	str		r0,[r4,18h]
	strh	r3,[r4,16h]
	strb	r3,[r4,1Ch]
	mov		r0,2h
	strb	r0,[r5,4h]
	ldrb	r0,[r4,8h]				;读取地面强制转身flag
	mov		r1,0h
	strb	r1,[r4,8h]
	cmp		r1,0h
	beq		@@CheckFloor
	bl		BeetomSpriteFacingExchange
@@CheckFloor:	
	ldrh	r0,[r4,2h]
	ldrh	r1,[r4,4h]				;检查脚下是否有砖
	bl		CheckBlock2
	ldr		r0,=XTagRAM
	ldrb	r0,[r0]
	cmp		r0,0h
	bne		@@end
	mov		r0,6h
	strb	r0,[r5,4h]				;Pose写入意外下落
@@end:	
	pop		r1
	bx		r1
.pool

BeetomNormalMovePose:				;2
	push	lr
	ldrb	r0,[r5,0Ch]
	cmp		r0,0h
	bgt		@@NoJump
	bl		CheckAnimation
	cmp		r0,0h
	beq		@@end
@@Jump:	
	mov		r0,0h
	strb	r0,[r5,0Ch]				;清空计数值
	mov		r0,3h
	strb	r0,[r5,4h]
	b		@@end
@@NoJump:
	sub		r0,1h
	strb	r0,[r5,0Ch]
	ldr		r6,=YTagRAM
	ldrh	r0,[r4]
	mov		r1,40h
	and		r1,r0
	cmp		r1,0h
	beq		@@FaceLeft
	ldrh	r0,[r4,2h]
	sub		r0,1h
	ldrh	r1,[r4,4h]
	add		r1,21h
	bl		CheckBlock3
	cmp		r0,0h
	beq		@@RightFloorCheck
	cmp		r0,11h
	bne		@@PlayStaightJump			;是坡直跳
	bl		BeetomSpriteFacingExchange		;是墙转向
	b 		@@LeftFloorCheck
.pool
@@PlayStaightJump:
	mov		r0,1h
	strb	r0,[r4,9h]					;强制直跳标记
	b		@@Jump
	
@@FaceLeft:
	ldrh	r0,[r4,2h]
	sub		r0,1h
	ldrh	r1,[r4,4h]
	sub		r1,21h
	bl		CheckBlock3
	cmp		r0,0h
	beq		@@LeftFloorCheck
	cmp		r0,11h
	bne		@@PlayStaightJump
	bl		BeetomSpriteFacingExchange
@@RightFloorCheck:
	ldrh	r0,[r4,2h]
	ldrh	r1,[r4,4h]
	add		r1,30h
	bl		CheckBlock
	ldrb	r0,[r6]
	mov		r1,10h
	and		r0,r1
	cmp		r0,0h
	beq		@@JumpOrEnd
	ldrh	r1,[r4,4h]
	add		r1,1h
	strh	r1,[r4,4h]
	b		@@end
@@LeftFloorCheck:
	ldrh	r0,[r4,2h]
	ldrh	r1,[r4,4h]
	sub		r1,30h
	bl		CheckBlock
	ldrb	r0,[r6]
	mov		r1,10h
	and		r0,r1
	cmp		r0,0h
	beq		@@JumpOrEnd
	ldrh	r1,[r4,4h]
	sub		r1,1h
	strh	r1,[r4,4h]
	b		@@end
@@JumpOrEnd:
	ldr		r1,=SpriteRNG
	ldrb	r0,[r1]
	mov		r1,3h
	and		r0,r1
	cmp		r0,3h
	beq		@@end
	b		@@Jump
.pool
@@end:
	pop		r1
	bx		r1
.pool

BeetomReJumpPose:						;分配给予何种跳跃
	push	lr
	ldr		r0,=BeetomJumpOAM
	str		r0,[r4,18h]
	mov		r0,0h
	strh	r0,[r4,16h]
	strb	r0,[r4,1Ch]
	strb	r0,[r5,0Ch]				;跳跃的帧数归零
	mov		r0,4h
	strb	r0,[r5,4h]
	ldrb	r0,[r4,9h]				;强制直立跳跃标记
	mov		r1,0h
	strb	r1,[r4,9h]				;强制直立跳跃标记归零
	cmp		r0,r1
	bne		@@JumpUp
	ldrb	r0,[r5,0Fh]				;检查samus在附近的标记
	cmp		r0,0h
	beq 	@@JumpUp
	cmp		r0,4h
	beq		@@SpriteToLeftFace
	ldrh	r0,[r4]
	mov		r1,40h
	and		r0,r1
	cmp		r0,0h
	bne		@@NoChangedFacing
	b		@@ChangedFacing
@@SpriteToLeftFace:	
	ldrh	r0,[r4]
	mov		r1,40h
	and		r0,r1
	cmp		r0,0h
	beq		@@NoChangedFacing
@@ChangedFacing:
	bl		BeetomSpriteFacingExchange
@@NoChangedFacing:	
	ldrb	r0,[r5,0Eh]				;前跳次数
	add		r0,1h
	strb	r0,[r5,0Eh]				;加一再写入
	mov		r0,2h					;前跳flag
	b		@@end
.pool	
@@JumpUp:							;向上跳	
	ldrb	r0,[r4,7h]				;直跳次数
	add		r0,1h
	strb	r0,[r4,7h]				;加1再写入
	ldrb	r0,[r4,8h]				;起跳强制转身标记
	mov		r1,0h
	strb	r1,[r4,8h]				;起跳强制转身标记归零
	cmp		r0,1h
	beq		@@Turn					;跳过随机判断强制转身
;	cmp		r0,2h
;	beq		@@NoTurnJump
	ldr		r0,=SpriteRNG
	mov		r3,r0
	ldrb	r0,[r0]
	mov		r1,3h
	and		r1,r0
	cmp		r1,0h
	beq		@@NoTurnJump
@@Turn:	
	bl		BeetomSpriteFacingExchange
@@NoTurnJump:	
	ldrb	r0,[r3]
	mov		r1,4h
	and		r0,r1
	cmp		r0,0h
	bne		@@HighJump
	b		@@end
.pool	
@@HighJump:
	mov		r0,1h
@@end:
	strb	r0,[r5,0Dh]				;跳跃的类型
	pop		r1
	bx		r1
.pool

BeetomJumpPose:
	push 	r4-r7,lr
	ldrb	r0,[r5,0Dh]
	cmp		r0,2h
	bne		@@StraightJump
	ldr		r0,=BeetomLeapForwardYSpeed
	b		@@Peer
	.pool
@@StraightJump:
	cmp		r0,1h
	beq		@@HighJump
	ldr		r0,=BeetomNormalJumpYSpeed
	b		@@Peer
	.pool
@@HighJump:
	ldr		r0,=BeetomHighJumpYSpeed
@@Peer:	
	mov		r7,r0
	ldrb	r2,[r5,0Ch]
	lsl		r2,r2,1
	add		r2,r2,r7
	ldrh	r6,[r2]					;当前的跳跃Y速度值
	mov		r3,0h
	ldsh	r1,[r2,r3]
	ldr		r0,=7FFFh
	cmp		r1,r0
	bne		@@SpeedValueNoEnd
	ldrb	r2,[r5,0Ch]
	sub		r2,1h
	strb	r2,[r5,0Ch]				;跳跃速度值到底了则减1
	lsl		r2,r2,1h
	add		r2,r2,r7
	ldrh	r6,[r2]
@@SpeedValueNoEnd:
	ldrb	r0,[r5,0Dh]				;检查是那种跳跃
	cmp		r0,2h
	beq		@@LeapForwardJump
	mov		r7,1h
	b		@@XMove
.pool	
@@LeapForwardJump:
	mov		r7,0Ch
@@XMove:	
	ldrh	r0,[r4]
	mov		r1,40h
	and		r0,r1
	cmp		r0,0h
	bne		@@WriteXY
	neg		r7,r7
@@WriteXY:
	ldrh	r3,[r4,4h]
	add		r7,r3,r7
	lsl		r7,r7,10h
	lsr		r7,r7,10h
	ldrh	r0,[r4,2h]
	add		r6,r0,r6
	lsl		r6,r6,10h
	lsr		r6,r6,10h
	strh	r6,[r4,2h]				;写入Y坐标
	strh	r7,[r4,4h]				;写入X坐标
	ldrh	r0,[r4]
	mov		r6,20h
	mov		r1,40h
	and		r0,r1
	cmp		r0,0h
	bne		@@CheckBlock			;向右的话直接跳转
	neg		r6,r6				
@@CheckBlock:
	ldrh	r1,[r4,4h]
	add		r1,r6
	lsl		r6,r1,10h
	lsr		r6,r6,10h
	ldrb	r0,[r5,0Dh]				;检查跳跃类型
	ldr		r7,=YTagRAM
	cmp		r0,2h
	bne		@@NoLeapForwardJump
	ldrh	r0,[r4,2h]
	sub		r0,1h
	mov		r1,r6
	bl		CheckBlock				;检查最下面的前面
	ldrb	r0,[r7]
	cmp		r0,11h
	beq		@@ForwardHaveBlock
	ldrh	r0,[r4,2h]
	sub		r0,20h
	mov		r1,r6
	bl		CheckBlock				;检查前中
	ldrb	r0,[r7]
	cmp		r0,11h
	beq		@@ForwardHaveBlock
	ldrh	r0,[r4,2h]
	sub		r0,40h
	ldrh	r1,[r4,4h]
	bl		CheckBlock				;检查上中
	ldrb	r0,[r7]
	cmp		r0,11h
	beq		@@TopHaveBlock
	ldrh	r0,[r4,2h]
	sub		r0,40h
	mov		r1,r6
	bl		CheckBlock				;检查额头
	ldrb	r0,[r7]
	cmp		r0,11h
	beq		@@ForwardHaveBlock
	b		@@CheckDownBlock
	.pool
@@NoLeapForwardJump:
	ldrh	r1,[r4,4h]
	ldrh	r0,[r4]
	mov		r2,40h
	and		r0,r2
	cmp		r0,0h
	bne		@@RightFacingMove
	add		r1,20h
	b		@@CheckTopBehind
@@RightFacingMove:
	sub		r1,20h
@@CheckTopBehind:	
	ldrh	r0,[r4,2h]
	sub		r0,40h
	bl		CheckBlock				;检查顶部后部
	ldrb	r0,[r7]
	cmp		r0,11h
	beq		@@TopHaveBlock
	ldrh	r0,[r4,2h]
	sub		r0,40h
	ldrh	r1,[r4,4h]
	bl		CheckBlock				;检查上中
	ldrb	r0,[r7]
	cmp		r0,11h
	beq		@@TopHaveBlock
	ldrh	r0,[r4,2h]
	sub		r0,20h
	mov		r1,r6
	bl		CheckBlock				;检查前中
	ldrb	r0,[r7]
	cmp		r0,11h
	beq		@@ForwardHaveBlock
	ldrh	r0,[r4,2h]
	sub		r0,40h
	mov		r1,r6
	bl		CheckBlock				;检查前上
	ldrb	r0,[r7]
	cmp		r0,11h
	beq		@@TopHaveBlock
@@CheckDownBlock:					;空中不碰壁
	ldrb	r2,[r5,0Ch]
	add		r2,1h
	strb	r2,[r5,0Ch]				;跳跃帧数增加
	ldrh	r0,[r4,2h]
	ldrh	r1,[r4,4h]
	bl		CheckBlock2				;检查地面
	mov		r1,r0
	ldr		r0,=XTagRAM
	ldrb	r0,[r0]
	cmp		r0,0h
	beq 	@@WillEnd				;不触地则结束
	strh	r1,[r4,2h]				;触地写入正确的Y坐标
	mov		r0,5h
	strb	r0,[r5,4h]				;Pose写入落地
	b		@@WriteNewOAM
	.pool
@@WillEnd:
	mov		r0,0h
	strb	r0,[r4,6h]				;清空碰壁值
	b		@@end
@@ForwardHaveBlock:
	ldrh	r3,[r4,4h]				;读取X坐标
	lsr		r3,r3,6h
	lsl		r3,r3,6h
	mov		r2,20h
	
	add		r3,r2
	lsl		r0,r3,10h
	lsr		r0,r0,10h
	strh	r0,[r4,4h]				;写入纠正的X坐标
	ldrb	r0,[r4,6h]
	add		r0,1h
	strb	r0,[r4,6h]				;撞壁次数加一
	ldrb	r0,[r5,0Dh]				;读取跳跃方式
	cmp		r0,2h
	bne		@@StaringhtJump			;如果是前跳的话立即转身
	bl		BeetomSpriteFacingExchange	;前跳碰面转身
	b		@@StaringhtJump
@@TopHaveBlock:	
	ldrh	r3,[r4,2h]
	lsr		r0,r3,6h
	lsl		r0,r0,6h
	add		r0,40h
	strh	r0,[r4,2h]				;写入纠正的Y坐标
@@StaringhtJump:
	mov		r0,6h
	strb	r0,[r5,4h]				;Pose写入意外落
@@WriteNewOAM:	
	ldr		r0,=BeetomNormalOAM
	str		r0,[r4,18h]
	mov		r0,0h
	strh	r0,[r4,16h]
	strb	r0,[r4,1Ch]
	
@@end:	
	pop		r4-r7
	pop		r1
	bx		r1
.pool

BeetomFallFloorPose:				;5 落地
	push	lr
	ldrh	r0,[r4,2h]
	sub		r0,1h
	ldrh	r1,[r4,4h]
	bl		CheckBlock3
	cmp		r0,0h
	beq		@@NoOnSlope
;	mov		r0,2h
;	strb	r0,[r4,8h]				;强制不转身标记
	mov		r0,1h
	strb	r0,[r4,9h]				;强制高跳标记
	mov		r0,3h
	strb	r0,[r5,4h]				;准备跳跃的Pose
	b		@@end
@@NoOnSlope:	
	ldrb	r0,[r5,0Dh]				;读取跳跃类型
	cmp		r0,2h
	bne		@@NoLeapForwardJump
	ldrb	r0,[r4,6h]
	cmp		r0,2h					;前跳碰壁次数大于等于2
	bcc		@@ContinuingForwardJumpCheck
	mov		r0,0h
	strb	r0,[r5,0Dh]				;跳跃类型重置
	strb	r0,[r4,6h]				;前跳碰壁次数归零
	add		r0,1h
	strb	r0,[r4,8h]				;写入强制转身标记
	strb	r0,[r4,9h]				;写入强制高跳标记
@@WritePose:	
	strb	r0,[r5,4h]				;写入写入移动的Pose
	b		@@end
@@ContinuingForwardJumpCheck:			
	mov		r0,1h					;Wait的Pose
	ldrb	r1,[r5,0Fh]				;检查是否在范围
	cmp		r1,0h
	beq		@@WritePose
	mov		r0,3h					;写入准备跳跃Pose
	b		@@WritePose
@@NoLeapForwardJump:
	ldr		r0,=SpriteRNG
	mov		r3,r0
	ldrb	r0,[r5,0Fh]				;检查是否在范围
	cmp		r0,0h
	beq		@@NoInRange
	mov		r0,1h					;WaitPose
	ldrb	r2,[r3]					;在范围内的话
	mov		r1,1h					;各半几率行走或直接跳
	and		r2,r1
	cmp		r2,0h
	beq		@@WritePose
	mov		r0,3h
	b		@@WritePose
	.pool	
@@NoInRange:	
	ldrb	r1,[r4,7h]				;连续直跳的次数
	ldrb	r2,[r3]
	mov		r0,1h					;WaitPose
	and		r1,r2
	cmp		r1,0h
	beq		@@WritePose
	mov		r0,3h					;准备跳跃Pose
	b		@@WritePose
@@end:	
	pop		r1
	bx		r1
.pool

BeetomFallPose:						;6 意外下落
	push	lr
	ldrh	r0,[r4,2h]
	add		r0,10h
	strh	r0,[r4,2h]
	ldrh	r1,[r4,4h]
	bl		CheckBlock2
	mov		r1,r0
	ldr		r0,=XTagRAM
	ldrb	r0,[r0]
	cmp		r0,0h
	beq		@@end
	strh	r1,[r4,2h]				;写入应有的Y坐标
	mov		r0,5h
	strb	r0,[r5,4h]
@@end:
	mov		r0,0h
	strb	r0,[r4,7h]				;连续直跳次数归零
	strb	r0,[r5,0Eh]				;连续前跳次数归零
	pop		r1
	bx		r1
.pool
	
BeetomReSuckPose:
	push	lr
	bl		BeetomSpriteSuckXY
	bl		CheckAnimation
	cmp		r0,0h
	beq		@@end
	ldr		r0,=BeetomSuckOAM
	str		r0,[r4,18h]
	mov		r0,0h
	strh	r0,[r4,16h]
	strb	r0,[r4,1Ch]
	mov		r0,8h
	strb	r0,[r5,4h]			;写入吸血的Pose
	mov		r0,18h				;大吸血	Metroid
	strb	r0,[r5,5h]			;写入属性
	bl		BeetomSuckSound
@@end:
	pop		r1
	bx		r1
.pool	

BeetomSuckPose:
	push	lr
	bl		BeetomSpriteSuckXY
	ldr		r0,=3000C77h		;8bit循环数
	ldrb	r0,[r0]
	mov		r1,1Fh
	and		r0,r1
	cmp		r0,1Fh
	bne		@@end
	bl		BeetomSuckSound
@@end:	
	pop		r1
	bx		r1
.pool

BeetomSuckSound:
	push	lr
	mov		r0,81h
	bl		PlaySound2
	ldr		r0,=Equipment
	ldrb	r0,[r0,0Fh]
	mov		r2,30h
	and		r2,r0
	cmp		r2,0h
	bne		@@CheckIFBothSuit
	ldr		r0,=16Dh
	bl		PlaySound
	b		@@end
	.pool
@@CheckIFBothSuit:
	cmp		r2,30h
	bne		@@OneSuit
	ldr		r0,=16Fh
	bl		PlaySound
	b		@@end	
	.pool
@@OneSuit:
	mov		r0,0B7h
	lsl		r0,r0,1h
	bl		PlaySound				;根据服装播放不同的喝血	
@@end:
	pop		r1
	bx		r1
	.pool
	
BeetomSpriteSuckXY:					;吸附samus
	ldr		r2,=3001600h			;Samus上一帧的坐标
	ldr		r0,=30015F8h
	mov		r1,0h
	ldsh	r0,[r0,r1]
	lsr		r1,r0,1Fh
	add		r0,r0,r1
	asr		r0,r0,1h
	ldrh	r1,[r2,2h]				
	add		r0,r0,r1				;敌人应写入的Y坐标
	add		r0,10h					;再加20h 比较合适
	lsl		r0,r0,10h
	lsr		r0,r0,10h
	strh	r0,[r4,2h]
	ldrh	r1,[r2]
	strh	r1,[r4,4h]
	bx		lr
.pool
	
BeetomCheckBomeOrPowerBomeAttack:
    push    r4-r7,lr				
    mov     r7,r10				
    mov     r6,r9				
    mov     r5,r8				
    push    r5-r7				
    add     sp,-18h				
    mov     r6,r0				
    add     r0,20h
	mov		r3,r0
    ldrb    r1,[r0,0Bh]				
    mov     r0,80h				
    and     r0,r1     	    ;读取击晕值			
    cmp     r0,0h      	 	;是否有80		
    beq     @@StunNo80  							
    mov     r0,62h				
    strb    r0,[r3,4h]     	;如果有80则pose写入62h 超炸直接炸死		
    b       @@end				
.pool				
				
@@BomeDamage:				
    add	    r0,r7,1h	
    lsl	    r0,r0,18h	
    lsr	    r7,r0,18h	
    b	    @@OverData
@@StunNo80:		
	ldrb	r0,[r3,6h]
	cmp		r0,0h
	bne		@@end
	ldrb	r0,[r3,0Bh]
	cmp		r0,2h
	bne		@@end
    mov     r7,0h				
    ldrh    r1,[r6,2h]    	;Y坐标			
    ldrh    r0,[r6,0Ah]   	;上部分界			
    add     r0,r1,r0				
    lsl     r0,r0,10h				
    lsr     r0,r0,10h				
    str     r0,[sp,10h]				
    ldrh    r0,[r6,0Ch]				
    add     r1,r1,r0				
    lsl     r1,r1,10h				
    lsr     r1,r1,10h				
    str     r1,[sp,14h]				
    ldrh    r1,[r6,4h]				
    ldrh    r0,[r6,0Eh]				
    add     r0,r1,r0				
    lsl     r0,r0,10h				
    lsr     r0,r0,10h				
    mov     r9,r0				
    ldrh    r0,[r6,10h]				
    add     r1,r1,r0				
    lsl     r1,r1,10h				
    lsr     r1,r1,10h				
    mov     r8,r1				
    ldr     r5,=3000A2Ch				
    mov     r1,0E0h				
    lsl     r1,r1,1h				
    add     r0,r5,r1			;最大的范围	
    cmp     r5,r0				
    bcs     @@OverData				
				
@@Loop:				
    ldrb    r0,[r5]				
    mov     r1,1h				
    and     r0,r1				
    cmp     r0,0h				;检查是否有弹丸
    beq     @@NextPro				
    ldrb    r0,[r5,0Fh]				
    cmp     r0,0Eh				;检查弹丸类型是否是炸弹	
    bne     @@NextPro				
    ldrb    r0,[r5,11h]				
    cmp     r0,3h				;检查炸弹的节奏
    bne     @@NextPro				
    ldrh    r3,[r5,8h]				
    ldrh    r4,[r5,14h]				
    add     r4,r3,r4			;蛋极上	
    lsl     r4,r4,10h				
    lsr     r4,r4,10h				
    ldrh    r0,[r5,16h]				
    add     r3,r3,r0				
    lsl     r3,r3,10h				
    lsr     r3,r3,10h				
    ldrh    r2,[r5,0Ah]				
    ldrh    r1,[r5,18h]				
    add     r1,r2,r1				
    lsl     r1,r1,10h				
    lsr     r1,r1,10h				
    ldrh    r0,[r5,1Ah]				
    add     r2,r2,r0				
    lsl     r2,r2,10h				
    lsr     r2,r2,10h				
    str     r4,[sp]				
    str     r3,[sp,4h]				
    str     r1,[sp,8h]				
    str     r2,[sp,0Ch]				
    ldr     r0,[sp,10h]				
    ldr     r1,[sp,14h]				
    mov     r2,r9				
    mov     r3,r8				
    bl		800E6F8h			;检查是否被炸弹炸到	
    cmp     r0,0h				
    bne     @@BomeDamage				
				
@@NextPro:				
    add     r5,1Ch				
    ldr     r0,=3000BECh				
    cmp     r5,r0				
    bcc     @@Loop				
				
@@OverData:				
    cmp     r7,0h	
	beq		@@end
			
    ldrh	r0,[r6,14h]				;读取血量
	sub		r0,BomeDamageDidBeetom	;减去炸弹的伤害
	cmp		r0,0h
	ble		@@Death
	strh	r0,[r6,14h]
	mov		r3,r6
	add		r3,20h
	mov		r0,10h
	strb	r0,[r3,6h]
	strb	r0,[r3,0Bh]
    b       @@end		
.pool				

@@Death:
	mov		r0,0h
	strh	r0,[r6,14h]
	mov		r0,62h
	add		r6,20h
	strb	r0,[r6,4h]
																				
@@end:				
    add     sp,18h				
    pop     r3-r5				
    mov     r8,r3				
    mov     r9,r4				
    mov     r10,r5				
    pop     r4-r7				
    pop     r0				
    bx      r0				
.pool

BeetomSpriteFacingExchange:					;敌人转向
	ldrh	r0,[r4]
	mov		r1,40h
	and		r1,r0
	cmp		r1,0h
	beq		@@FaceLeft
	ldr		r1,=0FFBFh
	and		r0,r1
	b		@@end
.pool
@@FaceLeft:
	mov		r1,40h
	orr		r0,r1
@@end:	
	strh	r0,[r4]
	bx		lr
.pool	

BeetomCheckSpriteAndSamusIntersects:
	push	r4-r7,lr
	add		sp,-10h
	ldrh	r0,[r4,2h]
	sub		r0,40h
	str		r0,[sp]				;精极上
	ldrh	r0,[r4,2h]
	str		r0,[sp,4h]			;精极下
	ldrh	r0,[r4,4h]
	sub		r0,21h				
	str		r0,[sp,8h]			;精极左
	ldrh	r0,[r4,4h]
	add		r0,21h
	str		r0,[sp,0Ch]			;精极右
	ldr		r0,=30013D4h
	ldrh	r6,[r0,14h]			;SaY
	ldrh	r7,[r0,12h]			;SaX
	ldr		r0,=30015F8h		;samus上部分界
	mov		r1,0h
	ldsh	r0,[r0,r1]
	add		r0,r6,r0
	lsl		r0,r0,10h
	lsr		r0,r0,10h			;人极上
	mov		r1,r6				;人极下
	mov		r2,r7
	sub		r2,1Ch
	lsl		r2,r2,10h
	lsr		r2,r2,10h			;人极左
	mov		r3,r7
	add		r3,1Ch				;人极右
	bl		800E6F8h
	cmp		r0,0h
	beq		@@end
	mov		r0,7h
	strb	r0,[r5,4h]			;Pose写入ReSuck
	ldr		r0,=BeetomReSuckOAM
	str		r0,[r4,18h]
	mov		r0,0h
	strh	r0,[r4,16h]
	strb	r0,[r4,1Ch]
	mov		r0,1h
	strb	r0,[r4,13h]			;标记吸附
@@end:	
	add		sp,10h
	pop		r4-r7
	pop		r1
	bx		r1
.pool

	
CancelSuckAndFrozening:
	push	lr
	ldrb	r0,[r5,4h]
	cmp		r0,7h
	bcc		@@PassRePose
	mov		r0,1h
	strb	r0,[r5,4h]			;Pose写为等待
	mov		r0,0h
	strb	r0,[r4,13h]			;suckflag去除
@@PassRePose:
	bl		MetroidFrozenRoutine
	pop		r1
	bx		r1
.pool

.org 0x8761d38
.align
BeetomLeapForwardYSpeed:
	.dh 0xFFE8,0xFFEC,0xFFF0,0xFFF8,0xFFF8
	.dh 0xFFFC,0xFFFC,0xFFFC,0xFFFE,0xFFFE
	.dh 0,0,0,0,0,0,0,0,0x2,0x2,0x4,0x4
	.dh 0x4,0x8,0x8,0x10,0x18,0x18,0x7FFF
.align
BeetomNormalJumpYSpeed:
	.dh 0xFFE0,0xFFE0,0xFFE0,0xFFE8,0xFFE8
	.dh	0xFFE8,0xFFF0,0xFFF0,0xFFF8,0XFFF8
	.dh	0xFFFC,0xFFFE,0xFFFE,0xFFFE,0XFFFE
	.dh 0,0,0,0,0,0x2,0x2,0x2,0x2
	.dh 0x4,0x4,0x4,0x4,0x8,0x8,0x10,0x10
	.dh	0x20,0x20,0x28,0x7FFF
.align
BeetomHighJumpYSpeed:
	.dh	0xFFD0,0xFFD0,0xFFD8,0xFFE0,0XFFE0
	.dh	0xFFE8,0xFFE8,0xFFF0,0xFFF0,0XFFFC
	.dh	0xFFFC,0xFFFC,0xFFFE,0xFFFE,0XFFFE
	.dh	0,0,0,0,0,0x2,0x2,0x2,0x2
	.dh 0x4,0x4,0x8,0x8,0x10,0x10,0x10
	.dh 0x18,0x20,0x20,0x28,0x7FFF
.align
BeetomGfxPointers:
.import "Beetom.Gfx.lz"	
.align
BeetomPalPointers:
.import "Beetom.Palette"

.align
BeetomNormalOAM:
	.word BeetomNormalOAM2
	.word 0xC
	.word BeetomNormalOAM1
	.word 0xC
	.word BeetomNormalOAM2
	.word 0xC
	.word BeetomNormalOAM3
	.word 0xC
	.word 0,0
.align
BeetomNormalOAM1:               
	.dh 0x3						;身姿高
	.dh 0x80EE,0x0000,0x820E	;大腿
	.dh 0x80F0,0x0005,0x820F	;下肢
	.dh 0x00F0,0x41F8,0x8200	;身体
BeetomNormalOAM2:	            
	.dh 0x4						;身姿中
	.dh 0x80EF,0x0000,0x820E    ;大腿
	.dh 0x00F8,0x0006,0x822F    ;下肢下
	.dh 0x00F0,0x41F8,0x8202    ;身体
	.dh 0x00F1,0x0005,0x820F    ;下肢上
BeetomNormalOAM3:	
	.dh	0x5						;身姿低
	.dh 0x00F0,0x0001,0x820E    ;大腿上
	.dh 0x00F8,0X0000,0X822E    ;大腿下
	.dh 0x00F8,0x0007,0x822F    ;下肢下
	.dh 0x00F2,0x0006,0x820F	;下肢上
	.dh 0x00F0,0x41F8,0x8204    ;身体
	
.align
BeetomJumpOAM:
	.word BeetomJumpOAM1
	.word 0x4
	.word BeetomJumpOAM2
	.word 0x8
	.word BeetomJumpOAM1
	.word 0x4
	.word BeetomNormalOAM1
	.word 0xFF
	.word 0,0
.align
BeetomJumpOAM1:
	.dh 0x4						;半伸腿
	.dh 0x40F6,0x21FF,0x820C    ;大腿
	.dh 0x00FF,0x000D,0x822F    ;下肢下
	.dh 0x00F7,0x000C,0x820F	;下肢上
	.dh 0x00F0,0x41F8,0x8200	;身体	
BeetomJumpOAM2:	
	.dh 0x4						;全伸腿
	.dh 0x0007,0x000D,0x822F    ;下肢下
	.dh 0x00FF,0x000C,0x820F	;下肢上
	.dh 0x40FA,0x0000,0x820C    ;大腿
	.dh 0x00F0,0x41F8,0x8200	;身体
	.align
BeetomReSuckOAM:
	.word BeetomReSuckOAM0		;绿眼高姿
	.word 04h					
	.word BeetomReSuckOAM1		;绿眼中姿
	.word 04h
	.word BeetomReSuckOAM2      ;绿眼低姿
	.word 04h
	.word 0,0
.align	
BeetomSuckOAM:
	.word BeetomSuckOAM0		;红眼中姿
	.word 04h
	.word BeetomSuckOAM1		;红眼高姿
	.word 04h
	.word BeetomSuckOAM0		;红眼中姿
	.word 04h
	.word BeetomSuckOAM2  		;红眼低姿
	.word 04h
	.word 0,0
.align	
BeetomSuckOAM0:
	.dh 0x5
	.dh	0x00F0,0x01FA,0x8211	;红眼	
	.dh 0x40F8,0x01F9,0x820C	;大腿
	.dh	0x00FD,0x01FF,0x822D	;小腿上部
	.dh	0x00FD,0x01F8,0x822C	;小腿下部
	.dh 0x00F0,0x41F8,0x8208	;身体
.align	
BeetomSuckOAM1:
	.dh 0x5		
	.dh	0x00F0,0x01FA,0x8210	;红眼
	.dh 0x40F8,0x01FA,0x820C	;大腿
	.dh	0x00FD,0x0000,0x822D	;小腿上部
	.dh	0x00FD,0x01F8,0x822C	;小腿下部
	.dh 0x00F0,0x41F8,0x8206	;身体
.align	
BeetomSuckOAM2:
	.dh 0x5
	.dh	0x00F0,0x01FA,0x8212	;红眼
	.dh 0x40F8,0x01F8,0x820C	;大腿
	.dh	0x00FD,0x01FE,0x822D	;小腿上部
	.dh	0x00FD,0x01F8,0x822C	;小腿下部
	.dh 0x00F0,0x41F8,0x820A	;身体	

.align	
BeetomReSuckOAM0:
	.dh 0x4		
	.dh 0x40F8,0x01FA,0x820C	;大腿
	.dh	0x00FD,0x0000,0x822D	;小腿上部
	.dh	0x00FD,0x01F8,0x822C	;小腿下部
	.dh 0x00F0,0x41F8,0x8206	;身体
.align	
BeetomReSuckOAM1:
	.dh 0x4
	.dh 0x40F8,0x01F9,0x820C	;大腿
	.dh	0x00FD,0x01FF,0x822D	;小腿上部
	.dh	0x00FD,0x01F8,0x822C	;小腿下部
	.dh 0x00F0,0x41F8,0x8208	;身体	
.align	
BeetomReSuckOAM2:
	.dh 0x4
	.dh 0x40F8,0x01F8,0x820C	;大腿
	.dh	0x00FD,0x01FE,0x822D	;小腿上部
	.dh	0x00FD,0x01F8,0x822C	;小腿下部
	.dh 0x00F0,0x41F8,0x820A	;身体

.close